OpenShot Audio Library | OpenShotAudio: juce::StringPool Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
juce::StringPool Class Reference

`#include <juce_StringPool.h>`

## Public Member Functions
| StringPool () noexcept
String | getPooledString (const String &original)
String | getPooledString (const char *original)
String | getPooledString (StringRef original)
String | getPooledString (String::CharPointerType start, String::CharPointerType end)
void | garbageCollect ()

## Static Public Member Functions
static StringPool & | getGlobalPool () noexcept

## Detailed Description

A StringPool holds a set of shared strings, which reduces storage overheads and improves comparison speed when dealing with many duplicate strings.

When you add a string to a pool using getPooledString, it'll return a character array containing the same string. This array is owned by the pool, and the same array is returned every time a matching string is asked for. This means that it's trivial to compare two pooled strings for equality, as you can simply compare their pointers. It also cuts down on storage if you're using many copies of the same string.

Definition at line 39 of file juce_StringPool.h.

## Constructor & Destructor Documentation

## ◆ StringPool()

juce::StringPool::StringPool | ( |  | ) |
| noexcept

Creates an empty pool.

Definition at line 30 of file juce_StringPool.cpp.

## Member Function Documentation

## ◆ garbageCollect()

void juce::StringPool::garbageCollect | ( |  | ) |

Scans the pool, and removes any strings that are unreferenced. You don't generally need to call this - it'll be called automatically when the pool grows large enough to warrant it.

Definition at line 147 of file juce_StringPool.cpp.

## ◆ getGlobalPool()

StringPool & juce::StringPool::getGlobalPool | ( |  | ) |
| staticnoexcept

Returns a shared global pool which is used for things like Identifiers, XML parsing.

Definition at line 158 of file juce_StringPool.cpp.

Referenced by juce::XmlElement::setTagName().

## ◆ getPooledString() [1/4]

String juce::StringPool::getPooledString | ( | const char * | original | ) |

Returns a pointer to a copy of the string that is passed in. The pool will always return the same String object when asked for a string that matches it.

Definition at line 100 of file juce_StringPool.cpp.

## ◆ getPooledString() [2/4]

String juce::StringPool::getPooledString | ( | const String & | original | ) |

Returns a pointer to a shared copy of the string that is passed in. The pool will always return the same String object when asked for a string that matches it.

Definition at line 130 of file juce_StringPool.cpp.

Referenced by juce::XmlElement::setTagName().

## ◆ getPooledString() [3/4]

String juce::StringPool::getPooledString | ( | String::CharPointerType | start,
|  | String::CharPointerType | end )

Returns a pointer to a copy of the string that is passed in. The pool will always return the same String object when asked for a string that matches it.

Definition at line 110 of file juce_StringPool.cpp.

## ◆ getPooledString() [4/4]

String juce::StringPool::getPooledString | ( | StringRef | original | ) |

Returns a pointer to a shared copy of the string that is passed in. The pool will always return the same String object when asked for a string that matches it.

Definition at line 120 of file juce_StringPool.cpp.

The documentation for this class was generated from the following files:

- juce_StringPool.h
- juce_StringPool.cpp